;pro newcol,xmax,ymax

;first run maketab to calculate colors from SED models.
;should sed_pap.pro use d=10 pc.

!p.multi=[0,2,3]
;loadct,5
loadct,13
set_plot,'ps'
device,xsize=6.5,ysize=8.25,/inches,$
/portrait,xoffset=1,yoffset=1,/color,bits=24,$
filename='cc.ps'

;Martin Cohen's fluxes
;readcol,'mainseq_strip.txt',b1ms,b2ms,b3ms,b4ms,jms,hms,kms,msxa,numline=33
;readcol,'mainseq_strip.txt',b1ms,b2ms,b3ms,b4ms,jms,hms,kms,msxa
readcol,'filterfluxes.txt',j,h,k,b1,b2,b3,b4,b5,b6,b7,nb,skipline=4
;readcol,'mips24.txt',b5ms,numline=33
;readcol,'mips24.txt',b5ms
;readcol,'cohen_n.txt',nbms
nms=n_elements(b1ms)
;b5ms=findgen(nms)*0.+999.
;b6ms=findgen(nms)*0.+9999.
;b7ms=findgen(nms)*0.+500.
;nbms=findgen(nms)*0.+799.
;NOTE, need to convert these to a distance, in fact, need to convert all of them
;to a common distance!!!

;compute reddening line from star fluxes
filtlam=[1.2,1.65,2.16,3.6,4.5,5.8,8.0,24.0,70.0,160.0,10.75]
Av=findgen(100)*3.
readcol,'../models/parfiles/r400_ice095.par',klam4,junk1,junk2,kkap4
;readcol,'r400.par',klam,junk1,junk2,kkap
readcol,'../models/parfiles/kmh.par',klam,junk1,junk2,kkap
filtkap=interpol(kkap,klam,filtlam)
filtkap4=interpol(kkap4,klam4,filtlam)
kapv=interpol(kkap,klam,0.55)
kapv4=interpol(kkap4,klam4,0.55)
red=fltarr(100,11,2)

;Jys at 0 mag at each wavelength (from Cohen)
filtfb=[1630.,1050.,667.,277.5,179.5,116.6,63.13,7.160,0.7972,0.160,37.77]
;chip's estimate in erg/s/cm^2/A
;filtfc=[3.15e-10,41.15e-10,4.45e-11,6.74e-12,$
;	2.73e-12,1.12e-12,3.19e-13]
;convert to Jys
;filtfc=filtfc*1.e23*(filtlam*1.e4)^2/2.9979e18
;chip has a typo at H so we'll use barb's for now

;convert everything to magnitudes
j=-2.5*alog10(j/filtfb(0))
h=-2.5*alog10(h/filtfb(1))
k=-2.5*alog10(k/filtfb(2))
b1=-2.5*alog10(b1/filtfb(3))
b2=-2.5*alog10(b2/filtfb(4))
b3=-2.5*alog10(b3/filtfb(5))
b4=-2.5*alog10(b4/filtfb(6))
b5=-2.5*alog10(b5/filtfb(7))
b6=-2.5*alog10(B6/filtfb(8))
b7=-2.5*alog10(b7/filtfb(9))
nb=-2.5*alog10(nb/filtfb(10))

for i=0,10 do begin
   red(*,i,0)=Av*filtkap(i)/kapv
   red(*,i,1)=Av*filtkap4(i)/kapv4
endfor

;concatenate Main sequence points with PMS
;j=[j,jms]
;h=[h,hms]
;k=[k,kms]
;b1=[b1,b1ms]
;b2=[b2,b2ms]
;b3=[b3,b3ms]
;b4=[b4,b4ms]
;b5=[b5,b5ms]
;b6=[b6,b6ms]
;b7=[b7,b7ms]
;nb=[nb,nbms]
;lab=['J', 'H', 'K', '3.6', '4.5', '5.8', '8.0']

;pick a distance
;d=4000
;d=500
;d=1000
d=140.
j=j-5+5*alog10(d)
h=h-5+5*alog10(d)
k=k-5+5*alog10(d)
b1=b1-5+5*alog10(d)
b2=b2-5+5*alog10(d)
b3=b3-5+5*alog10(d)
b4=b4-5+5*alog10(d)
b5=b5-5+5*alog10(d)
b6=b6-5+5*alog10(d)
b7=b7-5+5*alog10(d)
nb=nb-5+5*alog10(d)

;plot all fluxes, so skip the next several lines

;1 microJy sensitivity limit for 100 Lsun source 
;i.e., assume our source is 100 times brighter and
;compare to 1 uJy.  or compare our 1Lsun source to 1.e-8 Jy.
fmin=-2.5*alog10(1.e-8/filtfb)

;don't plot fluxes below fmin
a=where(j gt fmin(0),count)
if count ne 0 then j(a)=-30000
a=where(h gt fmin(1),count)
if count ne 0 then h(a)=-29000
a=where(k gt fmin(2),count)
if count ne 0 then k(a)=-28000
a=where(b1 gt fmin(3),count)
if count ne 0 then b1(a)=-27000
a=where(b2 gt fmin(4),count)
if count ne 0 then b2(a)=-26000
a=where(b3 gt fmin(5),count)
if count ne 0 then b3(a)=-25000
a=where(b4 gt fmin(6),count)
if count ne 0 then b4(a)=-24000
a=where(b5 gt fmin(7),count)
if count ne 0 then b5(a)=-23000
a=where(b6 gt fmin(8),count)
if count ne 0 then b6(a)=-22000
a=where(b7 gt fmin(9),count)
if count ne 0 then b7(a)=-21000
a=where(nb gt fmin(10),count)
if count ne 0 then nb(a)=-20000

;!p.multi(0)=2

redx=red(*,1,0)-red(*,2,0)
redy=red(*,0,0)-red(*,1,0)
redx4=red(*,1,1)-red(*,2,1)
redy4=red(*,0,1)-red(*,1,1)
plotcol,d,redx,redy,redx4,redy4,h-k,j-h,'H-K','J-H',-.3,4.,-.5,4.2,1,nms,$
-.1,-.25,5,Av

redx=red(*,2,0)-red(*,3,0)
redy=red(*,0,0)-red(*,1,0)
redx4=red(*,2,1)-red(*,3,1)
redy4=red(*,0,1)-red(*,1,1)
plotcol,d,redx,redy,redx4,redy4,k-b1,j-h,'K-[3.6]','J-H',-.5,3.5,0,3.5,0,nms,$
-0.,.6,5,Av

redy=red(*,2,0)-red(*,3,0)
redx=red(*,2,0)-red(*,10,0)
redy4=red(*,2,1)-red(*,3,1)
redx4=red(*,2,1)-red(*,10,1)
plotcol,d,redx,redy,redx4,redy4,k-nb,k-b1,'K-N','K-[3.6]',-.5,8,-1.,4.,0,nms,$
.5,.5,10,Av

redy=red(*,3,0)-red(*,4,0)
redx=red(*,5,0)-red(*,6,0)
redy4=red(*,3,1)-red(*,4,1)
redx4=red(*,5,1)-red(*,6,1)
plotcol,d,redx,redy,redx4,redy4,b3-b4,b1-b2,'[5.8]-[8.0]','[3.6]-[4.5]',-.5,2.0,-.5,2,0,nms,$
0,0,60,Av
;note, [3.6]-[4.5] colors go up to 15

redy=red(*,3,0)-red(*,5,0)
redx=red(*,6,0)-red(*,7,0)
redy4=red(*,3,1)-red(*,5,1)
redx4=red(*,6,1)-red(*,7,1)
plotcol,d,redx,redy,redx4,redy4,b4-b5,b1-b3,'[8.0]-[24]','[3.6]-[5.8]',-1.,10,-1,3,0,nms,$
0,0,60,Av

redy=red(*,6,0)-red(*,7,0)
redx=red(*,7,0)-red(*,8,0)
redy4=red(*,6,1)-red(*,7,1)
redx4=red(*,7,1)-red(*,8,1)
plotcol,d,redx,redy,redx4,redy4,b5-b6,b4-b5,'[24]-[70]','[8.0]-[24]',-4,8.0,0,10,0,nms,$
0,0,180,Av

device,/close
end
