c     ************************************************************
      subroutine densdisk(rad,sint,cost,phi,dens,idust2)

c     calculates density in disk with Gaussian scale height. 
c     called during grid setup so doesn't need to be optimized.

c  history:
c  00/09/06 (baw): write subroutine, modified from opacdiskg.f

      implicit none
      include 'tts.txt' 
      real*8 zp,rp,opacd,rad,sint,phi,dens,cost,gexp,zmr
      integer idust2

      rp=rad*sint
      zp=rad*cost
      zmr=z1*(rp/rmin)**b
c      if (abs(zp).lt.zmr.and.rp.lt.rmaxd) then 
c         idust2=1
c      else
c         idust2=2
c      endif
c      if (abs(zp).gt.5.*zmr) idust2=0

      if(rad.gt.rmaxd.or.rhod0.eq.0.d0.or.rad.lt.rddust.
     $     or.zmr.lt.1.d-10) then
         dens=0.d0
         if (rad.lt.rddust) idust2=4
         if (rad.gt.rmaxd) idust2=3
c     print*,'rad,rhod0 ',rad,rhod0
         return
      end if

c     print*,'sint,cost',sint,cost

      gexp=(zp/zmr)**2
      if(gexp.gt.1.d-15) then
         if(gexp.lt.120.d0) then
	    dens=rhod0*(rp/rmin)**(-a)*dexp(-0.5d0*gexp)*
     &           (1.d0-dsqrt(rmin/rp))
         else
	    dens=0.d0
	    idust2=3
         end if
      else
         dens=rhod0*(rp/rmin)**(-a)*(1.d0-dsqrt(rmin/rp))
      end if

      if (dens.gt.3.34e-16) then
         idust2=1
      else
         idust2=2
      endif

      return
      end
      
c     **********************************************************
