c     ***********************************************************
      subroutine densenv(rad,thetin,costin,sina,pi,pihalf,phi
     1              ,dens,radamb,idust2)

c     calculates density in envelope. called during grid setup
c     so doesn't need to be optimized.

c  history:
c  00/09/06 (baw): write subroutine, modified from opacenv.f
c  01/02/17 (baw): combine opacitybub subroutine into here.
c  01/30/05 (baw): modified for ellipsoidal envelope, instead of TSC.

      implicit none
      include 'opacin.txt' 
      include 'tts.txt'

      real*8 rad,dens,cosa,phi,thet,thetin,pihalf,pi,costin
     $     ,rp,zp,zup,radamb,sina
      integer idust2

c     for now, assuming +z = -z
      thet=thetin
      cosa=abs(costin)
      if (thet.gt.pihalf) thet=pi-thet
      rp=rad*sina
      zp=rad*cosa

c     envelope dust
      idust2=3

      if(rad.lt.rmax.and.rad.gt.rmine) then
         dens=rhoe0*(rad)**(-expe)/(1.+f_ellips**2*cosa**2)
      else
         dens=0.
      endif

      if (ihole.eq.1) then
         zup=c1e*rp**ex1+z01
         if (zp.gt.zup) then
            dens=rhoconst1*rad**(-exf)
            idust2=4
         endif
      endif

c     make density stop at r>rmax and r<rmine
      if (rad. gt. rmax) dens=0.d0
      if (rad. lt. rmine) dens=0.d0
c     compare to ambient density; if rho lt rhoamb, set rho to rhoamb.
      if(rad.gt.rmine.and.dens.lt.rhoamb) then
         dens=rhoamb
         if (rad.lt.radamb) radamb=rad
      endif

      return 
      end

