c     **********************************************************
      
      subroutine diskflux
c     
c     calculates flux from disk
c     
c     history:
c     2000/07/28 (mjw):  change filter on rtmp to .gt.1.d0
c
      
      implicit none
      
      include 'tts.txt'
      include 'stokes.txt'
      include 'vger.txt'

      real*8 rnorm,fimage,rnp,hstnorm,rtmp,xtmp,ytmp,norm
     1     ,thet,tmpsi

      integer i,ia,ix,iy,it,icenter,l,m,inub,ift
      
c     total flux from disk
      rnp=dfloat(np)
c     comparison with jon's code
      rnorm=rnp/dfloat(nmu)
      hstnorm=rnp
      do inub=1,nfreq
      do ia=1,3
      do i=1,nmu
         rtmp=dfloat(nums(inub,i,ia))
         if (rtmp.gt.1.d0)  then
c     errors, first, standard deviations
            tmpsi=si(inub,i,ia,1)+si(inub,i,ia,2)
            si2(inub,i,ia)=dsqrt((si2(inub,i,ia)-(tmpsi**2)
     1           /rtmp)/(rtmp-1.d0))
            sq2(inub,i,ia)=dsqrt((sq2(inub,i,ia)-(sq(inub,i,ia)**2)
     1           /rtmp)/(rtmp-1.d0))
            su2(inub,i,ia)=dsqrt((su2(inub,i,ia)-(su(inub,i,ia)**2)
     1           /rtmp)/(rtmp-1.d0))
            sv2(inub,i,ia)=dsqrt((sv2(inub,i,ia)-(sv(inub,i,ia)**2)
     1           /rtmp)/(rtmp-1.d0))
c     divide by average intensity per photon (assumes error
c     in I is 0)
            rtmp=tmpsi/dfloat(nums(inub,i,ia))
            si2(inub,i,ia)=si2(inub,i,ia)/rtmp
            sq2(inub,i,ia)=sq2(inub,i,ia)/rtmp
            su2(inub,i,ia)=su2(inub,i,ia)/rtmp
            sv2(inub,i,ia)=sv2(inub,i,ia)/rtmp
c     somewhat poisson in that errors should go down with more photons
            rtmp=dsqrt(dfloat(nums(inub,i,ia)))
            si2(inub,i,ia)=si2(inub,i,ia)/rtmp+1.d0/rtmp
            sq2(inub,i,ia)=sq2(inub,i,ia)/rtmp
            su2(inub,i,ia)=su2(inub,i,ia)/rtmp
            sv2(inub,i,ia)=sv2(inub,i,ia)/rtmp	   
         endif
c     if(i.eq.1.or.i.eq.nmu) then
c     si(inub,i,ia)=si(inub,i,ia)/rnorm*2.d0
c     sq(inub,i,ia)=sq(inub,i,ia)/rnorm*2.d0
c     su(inub,i,ia)=su(inub,i,ia)/rnorm*2.d0
c     sv(inub,i,ia)=sv(inub,i,ia)/rnorm*2.d0
c     bins 1 and nmu are half the size as the others
c     else
         si(inub,i,ia,1)=si(inub,i,ia,1)/rnorm
         si(inub,i,ia,2)=si(inub,i,ia,2)/rnorm
         sq(inub,i,ia)=sq(inub,i,ia)/rnorm
         su(inub,i,ia)=su(inub,i,ia)/rnorm
         sv(inub,i,ia)=sv(inub,i,ia)/rnorm
c     end if
      end do
         rtmp=dfloat(numt(inub,ia))
         if (rtmp.gt.1.d0) then
c     standard_deviation
            ti2(inub,ia)=dsqrt((ti2(inub,ia)-(ti(inub,ia)**2)/rtmp)
     1           /(rtmp-1.d0))
            tq2(inub,ia)=dsqrt((tq2(inub,ia)-(tq(inub,ia)**2)/rtmp)
     1           /(rtmp-1.d0))
            tu2(inub,ia)=dsqrt((tu2(inub,ia)-(tu(inub,ia)**2)/rtmp)
     1           /(rtmp-1.d0))
            tv2(inub,ia)=dsqrt((tv2(inub,ia)-(tv(inub,ia)**2)/rtmp)
     1           /(rtmp-1.d0))
c     divide by average i per photon
            rtmp=ti(inub,ia)/dfloat(numt(inub,ia))
            ti2(inub,ia)=ti2(inub,ia)/rtmp
            tq2(inub,ia)=tq2(inub,ia)/rtmp
            tu2(inub,ia)=tu2(inub,ia)/rtmp
            tv2(inub,ia)=tv2(inub,ia)/rtmp
c     account for somewhat poisson nature
            rtmp=dsqrt(dfloat(numt(inub,ia)))
            ti2(inub,ia)=ti2(inub,ia)/rtmp+1.d0/rtmp
            tq2(inub,ia)=tq2(inub,ia)/rtmp
            tu2(inub,ia)=tu2(inub,ia)/rtmp
            tv2(inub,ia)=tv2(inub,ia)/rtmp
         endif
         ti(inub,ia)=ti(inub,ia)/hstnorm
         tq(inub,ia)=tq(inub,ia)/hstnorm
         tu(inub,ia)=tu(inub,ia)/hstnorm
         tv(inub,ia)=tv(inub,ia)/hstnorm
         tis(inub,ia)=tis(inub,ia)/hstnorm
         tqs(inub,ia)=tqs(inub,ia)/hstnorm
         tus(inub,ia)=tus(inub,ia)/hstnorm
         tvs(inub,ia)=tvs(inub,ia)/hstnorm
      end do
      end do

      do inub=1,nfreq
      do it=1,nmu
c     if(it.eq.1.or.it.eq.nmu) then
c     star(inub,it)=star(inub,it)/(rnorm)*2.d0
c     else
         star(inub,it)=star(inub,it)/(rnorm)
c     end if
      end do
      end do

      do inub=1,nfreq
         estar(inub)=estar(inub)/hstnorm
      end do


c     check constants
c     rnorm has factor of 2*pi because you made all the photons
c     come out at one phi.  
c     rnorm=r2p*delnt*float(np)
c     that was the value for the correct rnorm.  using that
c     value, the flux at a given angle from the star, if there
c     is not absorbing disk, is 1/4pi.  We will multiply the
c     flux by 4pi so that it is normalized to the stellar flux.
c     rnorm=0.5*dmu*float(np)/normstar
      rnorm=0.5d0*dmu*dfloat(np)

c     multiply rnorm by 2 if you are doubling photons by
c     symmetry through z axis (in diskim)
c      rnorm=rnorm*2.d0
c      fimage=0.d0
c      print*,'normalizing flux image (not pol images) by ',rnorm
c     whenever we deal with bins 1 and nmu, multiply by 2 because
c     bin is half size of others.

c      icenter=nx/2+1
c      do it=1,nmu
c      do ix=1,nx
c      do iy=1,nx
c     standard deviation of imagei array
c         rtmp=dfloat(numi(ix,iy,it))
c         if (image2(ix,iy,it).gt.1.d0) then
c     print*,'rtmp',rtmp
c            image2(ix,iy,it)=(image2(ix,iy,it)-imagei(ix,iy,it)**2/rtmp)
c     1           /rtmp/(rtmp-1.d0)
c         endif
c         if(ix.eq.icenter.and.iy.eq.icenter) then
c            write(6,*) 'image before norm'
c     1           ,image(icenter,icenter,it),icenter,it
c         end if
c         if(image(ix,iy,it).lt.0.d0) then
c            write(6,*) 'before normalizing'
c            write(6,*) 'image lt 0',image(ix,iy,it),ix,iy,it
c         end if
c     if(it.eq.1.or.it.eq.nmu) then
c     image(ix,iy,it)=image(ix,iy,it)/(rnorm)*2.d0
c     else
c         image(ix,iy,it)=image(ix,iy,it)/(rnorm)
c     end if
c         fimage=fimage+(image(ix,iy,it))/dfloat(nmu)
c         if(ix.eq.icenter.and.iy.eq.icenter) then
c            write(6,*) 'image(icenter,icenter,it),icenter,it'
c     1           ,image(icenter,icenter,it),icenter,it
c         end if
c         if(image(ix,iy,it).lt.0.d0) then
c            write(6,*) 'image lt 0',image(ix,iy,it),ix,iy,it
c         end if
c      end do
c      end do
c      end do

      do ix=1,nxhst
      do iy=1,nxhst
      do ift=1,nbnd
         tihst(ix,iy,ift)=tihst(ix,iy,ift)/(hstnorm)
         tqhst(ix,iy,ift)=tqhst(ix,iy,ift)/(hstnorm)
         tuhst(ix,iy,ift)=tuhst(ix,iy,ift)/(hstnorm)
         tvhst(ix,iy,ift)=tvhst(ix,iy,ift)/(hstnorm)
      enddo
      enddo
      enddo

      norm=pi/bincvg*r2p/binpvg*dfloat(np)
      do l=1,ncvg
         thet=pi/bincvg*(dfloat(l)-0.5)
c     print*,'thet',thet
         do m=1,npvg
            ivg(l,m)=ivg(l,m)/norm/dsin(thet)
            qvg(l,m)=qvg(l,m)/norm/dsin(thet)
            uvg(l,m)=uvg(l,m)/norm/dsin(thet)
            vvg(l,m)=vvg(l,m)/norm/dsin(thet)
         enddo
      enddo
c     errors;
      if (countvg.gt.0) then
         rtmp=countvg
c     first, standard deviations
         ivgerr=dsqrt((ivgerr-ivgflux**2/rtmp)/(rtmp-1.d0))
         qvgerr=dsqrt((qvgerr-qvgflux**2/rtmp)/(rtmp-1.d0))
         uvgerr=dsqrt((uvgerr-uvgflux**2/rtmp)/(rtmp-1.d0))
         vvgerr=dsqrt((vvgerr-vvgflux**2/rtmp)/(rtmp-1.d0))
c     we've now calculated average q,u,v st.dev. per collected photon
c     want error in q/i, u/i, v/i
c     assume i has no error.  divide by average i per photon
         rtmp=ivgflux/countvg
         ivgerr=ivgerr/rtmp
         qvgerr=qvgerr/rtmp
         uvgerr=uvgerr/rtmp
         vvgerr=vvgerr/rtmp
c     now, it's not exactly poisson since each photon has a different
c     intensity, but the errors do decrease with increasing number
c     of photons.  so you want to decrease the errors by some
c     sqrt(1./n) type of number.  instead of using total number
c     of photons, we might vary it, make it smaller
         rtmp=dsqrt(1.d0*dfloat(countvg))
         ivgerr=ivgerr/rtmp+1./rtmp !in case st.dev.=0.
         qvgerr=qvgerr/rtmp
         uvgerr=uvgerr/rtmp
         vvgerr=vvgerr/rtmp
      endif
c     normalize 
      ivgflux=ivgflux/rnp
      qvgflux=qvgflux/rnp
      uvgflux=uvgflux/rnp
      vvgflux=vvgflux/rnp
      
c      write(6,*)'flux from image',fimage
      
      return
      end
      


c     *********************************************************
