      subroutine gridset

c  set up grid:  3-D spherical grid with variable spacing in r and 
c  theta (set by exponents, rexp, texp)
c  make a bunch of arrays necessary for find_wall subroutine

c history:
c 00/09/06 (baw): write subroutine
	
      implicit none
      include 'tts.txt'
      include 'out.txt'
      include 'grid.txt'
      include 'opacin.txt'
      include 'dust.com'

      real*8 dr,dt,dp,rad,phi,thet,pi,r2p,densd,dense,vol
     $ ,cost,sint,pihalf,eps,tau,rming1,rming2,rming3,tiny
     $     ,rmincgs,taud,taue,mu0,tauv,taufmin,mu,thetatm
     $     ,thetmin,tauzrat,sigmu,rsonr,Tdisk,taudisk
     $     ,mudisk,c1,a1,tauw,rtop,rfac,tauRr,taumid,tauRth
     $     ,tauRos,res
      real xyarr(200,200),x,y,xmax,dx,r,dens1
      real chiR,ierfc
      integer ir,it,ip,nttmp,gflag,n,ix,iy,nr0,ntatm,nrwall,irbeg

      pi=4.d0*datan(1.d0)
      r2p=2.d0*pi
      pihalf=pi/2.d0
      tiny=1.d-15
      rmincgs=rstar*rsol

c     convert opacity to units of cm^2/gm*rstar(cgs) because distance
c     is in units if 1/rstar, and dtau=kapd*rho*ds
      kapd=kappav*rmincgs
c     print*,'kappav',kappav
c     stop

c     calculate some constants for the TSC envelope density
      call envset

c     make grid include minimum and maximum values.

      print*, ' '
      print*, 'grid setup'
      pihalf=pi/2.d0

      print*,'rddust,rmine,rmin',rddust,rmine,rmin
c     rgrid
      gflag=0
      rarr(1)=rmin
      if (rddust.lt.rmine) then
         gflag=1
         rarr(2)=rddust
         rming1=rddust
         rming2=rmine
         irbeg=2
      else if (rddust.gt.rmine) then
         gflag=2
         rarr(2)=rmine
         rming1=rmine
         rming2=rddust
         irbeg=3
      else if (rddust.eq.rmine) then
         gflag=3
         rarr(2)=rmine
         rming1=rmine
         irbeg=2
      endif
      if (massd.eq.0.) then
c     since there's empty space below rmine and rddust....
         dr=(rmax-rming1)/(dfloat(nrg-2))**rexp
         print*,'rexp,dr,rmin',rexp,dr/autors,rmin/autors
         do ir=3,nrg
            rarr(ir)=rming1+dr*(dfloat(ir-2))**rexp
c     print*,'rarr ',ir,rarr(ir)/au
         enddo
         
      else
c     lots of fine spacing in inner region of disk
         
         a1=1.d0-a
         
         mu0=z1*Rddust**b/Rddust
         tauv=taur
         tauzrat=sqrt(pihalf)*a1*mu0/((rmaxd/rddust)**a1-1.)
         tauRos=tauv*chiR(1600./11605.)
         tauRth=tauzrat*tauRos
         taudisk=10.0
         
         print*,'tauRos,tauv,tauRth',tauRos,tauv,tauRth
         tauw=0.5
         rfac=(1.-(tauw*(1.-(rmaxd/rddust)**a1))/tauRos)**(1./a1)
         if (rfac.lt.1.00000001d0) then
            print*,''
            print*,'WARNING: not enough precision to resolve inner disk'
            print*,'rfac = ',rfac
            rfac=rfac*2.d0
            print*,'resetting rfac = ',rfac
            print*,''
         endif

         mu=sqrt(2.0)*ierfc(sngl(taudisk/tauRth))
         rtop=Rddust*(1.-(taudisk*(1.-(rmaxd/rddust)**a1))/
     +        (tauRos*exp(-0.5*mu*mu))      )**(1./a1)
         
         
         print*,'rfac,rtop,mu',rfac,rtop,mu
c         rarr(1)=rmin
c         rarr(2)=rmine
c         rarr(3)=rddust
         ir=irbeg
         rarr(ir)=rddust
         do while ((rarr(ir).lt.rtop).and.(ir.lt.(nrg-1)))
            rarr(ir+1)=rfac*rarr(ir)
            rfac=rfac**1.1
            ir=ir+1
         end do
         if(ir.ge.nrg) then
            write(*,*) 'too many points in rgrid'
            stop
         endif
         nrwall=ir
         print*,'nrwall,rarr(nrwall)',nrwall,rarr(nrwall)
         
         
c     rarr(1)=rmin
c     rarr(2)=rmine
c     rarr(3)=rddust
c     c1=chiR(1600./11605.)*kappav*rho0*rmincgs**a
c     nrwall=50
c     print*,'c1,a1',c1,a1
c     do ir=4,nrwall
c     tauw=ir*.5
c     rarr(ir)=(tauw*a1/c1+(rddust*rmincgs)**a1)**(1.d0/a1)
c     $        /rmincgs
c     print*,rarr(ir)
c     enddo
         rming1=rarr(nrwall)
         dr=(rmax-rming1)/(dfloat(nrg-nrwall))**rexp
         print*,'rexp,dr,rmin',rexp,dr/autors,rming1
         do ir=nrwall+1,nrg
            rarr(ir)=rming1+dr*(dfloat(ir-nrwall))**rexp
         enddo
         
c     if (gflag.eq.1.or.gflag.eq.2) then
c     call locate(rarr,nrg,rming2,ir)
c     rarr(ir+1)=rming2
c     endif
         
         
      endif

c     set rmine to a grid location
      if (gflag.eq.1) then
         call locate(rarr,nrg,rmine,ir)
         rarr(ir+1)=rmine
      endif

c     r-squared array
      do ir=1,nrg
         r2arr(ir)=rarr(ir)**2
c     print first few points of rarr
         if (ir.lt.10) then
            print*,'rarr/rmin,ir ',rarr(ir)/rmin,ir
         endif
      enddo

      open(unit=15,file='rarr.dat',status='unknown')
      write(15,*) nrg,' = number of grid points in r'
      write(15,*) 'index     r/rstar  r(au)'
      do ir=1,nrg
         write(15,*) ir,(rarr(ir)),sngl(rarr(ir)/autors)
      enddo
      close(15)

      print*,'rarr(nrg),r2arr(nrg)',rarr(nrg),r2arr(nrg)

      if (ntg.gt.1) then
c     set up a tmp array going from 0 - 90 from equ. to pole
         if (massd.eq.0.d0) then

            ntatm=1
            thetatm=0.d0
            tmptharr(1)=0.d0

         else

c     taufmin=min(0.1,0.1*kappaf*tauv)
            taufmin=min(.001,0.001*kappaf*tauv)
            
            print*,'kappaf*tauv',kappaf*tauv
            
            mu=min(mu0*sqrt(2.*dlog(tauv*kappaf/taufmin)),0.5)
            print*,'tauv,kappaf,taufmin',tauv,kappaf,taufmin

c     ************
c     for disk-only model, let mu=0.5 to sample entire disk height
c     at high-res
c     mu=0.5
c     ***********

            thetatm=pihalf-acos(mu)
c     test
            print*,'thetatm',thetatm*180./pi
            nttmp=(ntg+1)/2

c     *********************
c     change this for disk or envelope runs
c     for envelope with 1 degree resolution in polar region
            res=1.
c     for disk with nothing in the polar region
c     res = size of angle bin in poles, approximately 
c     res=10.
c     *********************

            ntatm=nttmp-(pihalf-thetatm)*90./pihalf/res

            thetmin=min(0.1*asin(mu0),thetatm/ntatm)
            
            tmptharr(1)=0.d0
            do it=2,ntatm
               tmptharr(it)=thetmin *
     1              (thetatm/thetmin)**((it-2.d0)/(ntatm-2.d0))
c     print*,'tmptharr ',tmptharr(it)*180.d0/pi
            enddo
            
         endif
         do it=ntatm+1,nttmp-1
            tmptharr(it)=thetatm+
     1           (it-ntatm)*(pihalf-thetatm)/(nttmp-ntatm)
         end do
         tmptharr(nttmp)=pihalf
         
         thetarr(nttmp)=pihalf
         do it=2,nttmp-1
            thetarr(nttmp+1-it)=pihalf-tmptharr(it)
            thetarr(nttmp-1+it)=pihalf+tmptharr(it)
         enddo
         thetarr(1)=0.d0
         thetarr(ntg)=pi
         
c     this is not the eps used in the rest of the code!  see
c     newdisktherm for that
         eps=1.d-8
         do it=1,ntg
            if (thetarr(it).lt.0) then
               thetarr(it)=0.d0
               costarr(it)=1.d0
               sintarr(it)=0.d0
            else if (thetarr(it).gt.pi) then
               thetarr(it)=pi
               costarr(it)=-1.d0
               sintarr(it)=0.d0
            else
               costarr(it)=cos(thetarr(it))
               sintarr(it)=sin(thetarr(it))
            endif
            if(thetarr(it).gt.(pihalf-eps).and.thetarr(it).lt.
     1           (pihalf+eps)) 
     1           then
               tan2arr(it)=-1.d0
            else
               tan2arr(it)=tan(thetarr(it))**2
            endif
c     print*,'thetarr,costarr,tan2arr '
c     print*,'thetarr',thetarr(it)*180.d0/pi
         enddo
      else
         thetarr(1)=0.d0
      endif

      open(unit=15,file='tharr.dat',status='unknown')
      write(15,*) ntg,' = number of grid points in theta'
      write(15,*) 
     1     'index  thet(rad)  thet(deg)    cost     tan**2(thet)'
      do it=1,ntg
         write(15,*) it,sngl(thetarr(it)),sngl(thetarr(it)*180.d0/pi),
     1        sngl(costarr(it)),sngl(tan2arr(it))
      enddo
      close(15)

      if (npg.gt.1) then
         dp=r2p/dfloat(npg-1)
         do ip=1,npg
            phiarr(ip)=dp*(dfloat(ip-1))
            aarr(ip)=dsin(phiarr(ip))
            barr(ip)=-dcos(phiarr(ip))
c     print*,'phiarr, aarr, barr ',phiarr(ip),aarr(ip),barr(ip)
c     carr(ip)=
c     darr(ip)=
         enddo
      else
         dp=r2p
         ip=1
         phiarr(ip)=0.d0
         aarr(ip)=dsin(phiarr(ip))
         barr(ip)=-dcos(phiarr(ip))
      endif

      open(unit=15,file='phiarr.dat',status='unknown')
      write(15,*) npg
      do ip=1,npg
         write(15,*) phiarr(ip)*180.d0/pi
      enddo
      close(15)

c     set up diffusion grid
      if (massd.eq.0.d0) then
         do ir =1,nrg
         do it=1,ntg
         do ip=1,npg
            diffus(ir,it,ip)=.false.
         enddo
         enddo
         enddo
      else
         if (rddust.eq.rmin) then 
            nr0=1
         else
            nr0=3
            do it=1,ntg
               do ip=1,npg
                  diffus(1,it,ip) = .false.
               end do
            end do
         endif
         do ir=nr0,nrg-1
            r=0.5*(rarr(ir)+rarr(ir+1))/rddust
            sigmu=mu0*r**(b-1.)
            Rsonr=1./(rddust*r)
            Tdisk=min(1600./11605.,max(3./11605.,(Tstar/11605.)*(
     +           max(2./3.*(Rsonr)**3,
     +           (asin(Rsonr)-(Rsonr)*sqrt(1.-(Rsonr)**2)))/pi
c     +        +   (3.*Lacc*(Rsonr)**3*(1.-sqrt(Rsonr)))
     +           )**0.25))
            taumid=tauzrat*tauv*chiR(sngl(Tdisk))/r**(a-b)
            if (taumid.gt.taudisk) then
               mudisk=sigmu*sqrt(2.)*ierfc(sngl(taudisk/taumid))
            else
               mudisk=0.
            endif
c     print*,'ir,taudisk,taumid,mudisk',ir,taudisk,taumid,mudisk
            if (ntg.gt.1) then
               do it=1,ntg-1
                  mu=abs(cos(0.5d0*(thetarr(it)+thetarr(it+1))))
                  tauRr=tauRos*exp(-0.5d0*mu*mu/(sigmu*sigmu))*
     +                 (1.d0-r**a1)/(1.d0-(rmaxd/rddust)**a1)
                  do ip=1,npg
                     if ((mu.lt.mudisk).and.(tauRr.gt.taudisk)) then
                        diffus(ir,it,ip) = .true.
c     print*,'true'
                     else
                        diffus(ir,it,ip) = .false.
c     print*,'mu,mudisk,tauRr,taudisk'
c     print*,mu,mudisk,tauRr,taudisk
c     print*,'false'
                     endif
                  end do
               end do
            else
               do it=1,ntg
                  do ip=1,npg
                     diffus(ir,it,ip) = .false.
                  end do
               end do
            endif
         end do
      endif

      open(unit=15,file='diffuse.unf',status='unknown',
     1     form='unformatted')
      write(15) nrg,ntg,npg
      write(15) (rarr(ir)/autors,ir=1,nrg)
      write(15) (thetarr(it),it=1,ntg)
      write(15) (phiarr(ip),ip=1,npg)
      write(15) (((diffus(ir,it,ip),ir=1,nrg),it=1,ntg)
     1     ,ip=1,npg)
      close(15)
c      print*,'massd',massd
c      stop

c     calculate density in grid
      massenv=0.d0
      massdisk=0.d0
      do ir=1,nrg-1
         rad=0.5d0*(rarr(ir)+rarr(ir+1))
         dr=rarr(ir+1)-rarr(ir)
         if (ntg.gt.1) then     !2- or 3-D atmosphere
            do it=1,ntg-1
               thet=0.5d0*(thetarr(it)+thetarr(it+1))
               cost=cos(thet)
               sint=sin(thet)
               dt=thetarr(it+1)-thetarr(it)
               if (npg.gt.1) then
                  do ip=1,npg-1   !3-D atmosphere
                     tdust(ir,it,ip)=0.d0
                     nabs(ir,it,ip)=0
                     phi=0.5d0*(phiarr(ip)+phiarr(ip+1))
                     dp=phiarr(ip+1)-phiarr(ip)
                     call densenv(rad,thet,cost,sint,pi,pihalf,phi
     1                    ,dense)
                     vol=rad**2*sint*dt*dp*dr*rmincgs**3
                     massenv=massenv+dense*vol
                     call densdisk(rad,sint,cost,phi,densd)
                     massdisk=massdisk+densd*vol
                     densarr(ir,it,ip)=dense+densd
                     massarr(ir,it,ip)=(dense+densd)*vol
                     massarr(ir,it,ip)=massarr(ir,it,ip)**0.25
                  end do
               else           !2-D atmosphere
                  ip=1       
                  phi=0.d0
                  dp=r2p
                  tdust(ir,it,ip)=0.d0
                  nabs(ir,it,ip)=0
                  call densenv(rad,thet,cost,sint,pi,pihalf,phi
     1                 ,dense)
                  vol=rad**2*sint*dt*dp*dr*rmincgs**3
                  massenv=massenv+dense*vol
                  call densdisk(rad,sint,cost,phi,densd)
                  massdisk=massdisk+densd*vol
                  densarr(ir,it,ip)=dense+densd
                  massarr(ir,it,ip)=(dense+densd)*vol
                  massarr(ir,it,ip)=massarr(ir,it,ip)**0.25
               endif
            enddo
         else              !1-D atmosphere
            phi=0.d0
            ip=1
            it=1
            tdust(ir,it,ip)=1000.d0/11605.d0
            nabs(ir,it,ip)=0
            thet=60.d0*pi/180.d0
            cost=cos(thet)
            sint=sin(thet)
            call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense)
            vol=rad**2*dr*2.d0*r2p*rmincgs**3
            massenv=massenv+dense*vol
            call densdisk(rad,sint,cost,phi,densd)
            massdisk=massdisk+densd*vol
            densarr(ir,it,ip)=dense+densd
            massarr(ir,it,ip)=(dense+densd)*vol
            massarr(ir,it,ip)=massarr(ir,it,ip)**0.25
c     print*,'densarr',densarr(ir,it,ip)
         endif
      end do
      massenv=massenv/1.989d33
      massdisk=massdisk/1.989d33
c     important note:  densarr(ir,it,ip) is the density halfway between
c     ir and ir+1, it and it+1, ip and ip+1; it is NOT the density at
c     ir,it,ip.

      print*, 'massenv (in solar units) ',massenv
      print*, 'massdisk from grid, compared to input ',massdisk,
     $     massd
      print*, ' '

c     write out rarr,thetarr,densarr at phi=0 so you can read them into
c     IDL.


c     integrate optical depth along the theta angles
c     at phi=0.
      open(unit=15,file='tau.dat',status='unknown')
      write(15,*) 
     1 '    theta          tau_env        tau_disk       tau_tot'
      do it=1,ntg
         tau=0.d0
         taud=0.d0
         taue=0.d0
         if (ntg.eq.1) then
            thet=60.d0*pi/180.d0
         else
            thet=thetarr(it)
         endif
         if (ntg.gt.1.and.it.eq.(ntg/2)+1) then
c     TSC blows up at thet=90
            print*,'thet',thet*180./pi
            thet=89.999d0*pi/180.d0
         endif
         cost=cos(thet)
         sint=sin(thet)
         phi=0.d0
         do ir=1,nrg-1
            dr=rarr(ir+1)-rarr(ir)
            rad=0.5d0*(rarr(ir)+rarr(ir+1))
            call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense)
            call densdisk(rad,sint,cost,phi,densd)
            taud=taud+kapd*(densd)*dr
            taue=taue+kapd*(dense)*dr
         end do
         write(15,*) sngl(thet*180.d0/pi),sngl(taue)
     1        ,sngl(taud),sngl(taue+taud)
      end do
      close(15)

c     integrate Av along equatorial direction
      taud=0.d0
      taue=0.d0
      thet=90.d0*pi/180.d0
      cost=0.d0
      sint=1.d0
      phi=0.d0
      do ir=1,nrg-1
         dr=rarr(ir+1)-rarr(ir)
         rad=0.5d0*(rarr(ir)+rarr(ir+1))
c     call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense)
         call densdisk(rad,sint,cost,phi,densd)
         taud=taud+kappav*rmincgs*(densd)*dr
c     taue=taue+kappav*rmincgs*(dense)*dr
         tauarr(ir)=taud
      enddo

c     calculate Av along ethet,ephi directions (peeled image)
      open(unit=15,file='A_v.dat',status='unknown')
      write(15,*) 
     1 'theta   Av_env       Av_disk      Av_tot'
      thet=thete
      cost=cos(thet)
      sint=sin(thet)
      phi=0.d0
      taud=0.d0
      taue=0.d0
      do ir=1,nrg-1
         dr=rarr(ir+1)-rarr(ir)
         rad=0.5d0*(rarr(ir)+rarr(ir+1))
         call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense)
         call densdisk(rad,sint,cost,phi,densd)
         taud=taud+kappav*rmincgs*(densd)*dr
         taue=taue+kappav*rmincgs*(dense)*dr
      end do
      write(15,*) sngl(thet*180.d0/pi),sngl(taue*1.086)
     1     ,sngl(taud*1.086),sngl((taue+taud)*1.086)
      close(15)

      r=1.d0*autors
      call locate(rarr,nrg,dble(r),ir)
      dens1=densarr(ir,1,1)
      print*,'r,dens1',r,dens1

c     write out density array to read in IDL
c     make the cartesian grid here (fortran is faster than IDL)
c     this makes a grid in the x-z plane
      n=200
c     xmax=sngl(rarr(nrg))
c     xmax=rmaxd
      xmax=sngl(xymaxdens)
      print*,'xmax',xmax
      dx=xmax/float(n)
      do ix=1,n
         x=dx*(float(ix)-0.5)
      do iy=1,n
         y=dx*(float(iy)-0.5)
         if (iy.eq.1.and.ix.eq.1) print*,'x0,y0',x,y
         r=sqrt(x**2+y**2)
         thet=atan2(y,x)
         call locate(rarr,nrg,dble(r),ir)
         if (ntg.gt.1) then
            call locate(thetarr,ntg,(thet),it)
         else
            it=1
         endif
         xyarr(ix,iy)=sngl(densarr(ir,it,1))
      end do
      end do
      open(unit=15,file='densxz.dat',status='unknown')
      do ix=1,n
         write(15,*) (xyarr(ix,iy),iy=1,n)
      enddo
      close(15)

c     write out array in x-y plane at z=.5*rmax to see phi dependence
      thet=pi/2.d0
      if (ntg.gt.1) then
         call locate(thetarr,ntg,(thet),it)
c     print*,'it',it
      else
         it=1
      endif
      do ix=1,n
         x=dx*(float(ix)-0.5)
      do iy=1,n
         y=dx*(float(iy)-0.5)
         if (iy.eq.1.and.ix.eq.1) print*,'x0,y0',x,y
         r=sqrt(x**2+y**2)
         phi=atan2(y,x)
         call locate(rarr,nrg,dble(r),ir)
c     print*,'ir',ir
         if (npg.gt.1) then
            call locate(phiarr,npg,(phi),ip)
         else
            ip=1
         endif
         xyarr(ix,iy)=sngl(densarr(ir,it,ip))
      end do
      end do
      open(unit=15,file='densxy.dat',status='unknown')
      do ix=1,n
         write(15,*) (xyarr(ix,iy),iy=1,n)
      enddo
      close(15)

      end


      







