c     ********************************************************

      subroutine initpacc(ii,eps,nphot)

c     initialize variables for new accretion photon 

      implicit none

      real*8 xran,costi,sinti,cospn,phinew,winv
     +     ,T,T4eff,cosbnew,sinbnew,sth,mu,T4d,T4s,T4
     +     ,dA,suz,suy,sux,rnew,eps
      real c2p,s2p,cp,sp
      real ran2,gasdev,dBBfreq,chiR,dusttemp

      integer ii(3),ir,it,ip,i,nphot,nacc,idust2

      include 'tts.txt'
      include 'stokes.txt'
      include 'random.txt'
      include 'grid.txt'
      include 'taunum.txt'
      include 'dust.com'
 
C     find photon position

   10 continue

c     only emitting photons in disk.  adjust accretion
c     luminosity accordingly.
      rp=0.d0
      do while ((rp.ge.rmaxd).or.(rp.le.rddust))
         winv=ran2(i1)
         do while(ran2(i1).gt.(1.-sqrt(winv)))
            winv=ran2(i1)
         end do
         rp=1.d0/winv
      enddo
      
      call rantheta(sp,cp,s2p,c2p)
      xp=rp*cp
      yp=rp*sp
      zp=z1*rp**b*gasdev(i1)
     
      sip=1.d0
      sqp=0.d0
      sup=0.d0
      svp=0.d0
      
      rsq=rp**2+zp**2
      rtot=dsqrt(rsq)
      call locate(r2arr,nrg,rsq,ir)
c      if (ntg.gt.1) then
         cosb=zp/rtot
         call locate(costarr,ntg,cosb,it)
c      else
c         it=1
c      endif
c      if (npg.gt.1) then
         lp=datan2(yp,xp)
         if (lp.lt.0.d0) lp=lp+r2p
         call locate(phiarr,npg,lp,ip)
         if (ip.gt.1) then
            print*,'error in 2-D code; ip should be 1',ip
         endif
c      else
c         ip=1
c      endif
      ii(1)=ir
      ii(2)=it
      ii(3)=ip
      idust2=dustarr(ir,it,ip)
c      print*,''
c      print*,'rsq.rtot,zp',rsq,rtot,zp,ir,it,ip,diffus(ir,it,ip)


      nabs(ir,it,ip)=nabs(ir,it,ip)+1

      if (.not.diffus(ir,it,ip)) then
         tdust(ir,it,ip)=dusttemp(ir,it,ip,dble(nabs(ir,it,ip))
     1        ,sngl(tdust(ir,it,ip)),rstar,tstar,nphot,idust2)
         call reemit(sngl(tdust(ir,it,ip)),idust2)
c     set photon origin to disk or envelope
         uy=sint*sinp
         ux=sint*cosp
         uz=cost
      else
c     nabs in diffusion layer only consists of accretion photons
c     march through theta array to find theta of first non-diffusion
c     cell
c     call emitdiff(ir,it,ip,xp,yp,zp)
c     print*,'in diffusion region'

c     find diffusion direction

         if (abs(diffdir(ir,it,ip)) .eq. 1) then

            if (diffdir(ir,it,ip).eq. 1) then
               write(*,*) 'error, positive r diffusion not supported'
               stop
            endif

c     diffuse to front of disk

c     print*,'check: rtot,rarrs',rtot,rarr(ir),rarr(ir+1)
c     print*,'rsq,arrays',rsq,r2arr(ir),r2arr(ir+1)
c     print*,'diffdir',diffdir(ir,it,ip)
c     print*,'should be same',rtot,ir
c     print*,ii(1),ir
c     call testgrid(xp,yp,zp,rsq,rtot,ii,
c     +              'before diffusion',iphot,r2p,cost)
c     okay, we are where we think we are

            do while (diffdir(ir,it,ip) .eq. -1) !find diff surface
               ir=ir-1
            enddo
            ir=ir+1             !point to lower wall of 1st diffusion cell
            rnew=rarr(ir)-10.*eps*(rarr(ir)-rarr(ir-1))
c     if (rnew.gt.rtot) print*,'rnew>rtot',rnew,rtot
c     print*,'eps,rnew,rtot',eps,rnew,rtot
c     rnew=0.9999999d0*rarr(ir) !move photon into cell above diff layer
            xp=xp*rnew/rtot
            yp=yp*rnew/rtot
            rp=dsqrt(xp**2+yp**2)
            zp=zp*rnew/rtot
            rtot=rnew
            rsq=rnew*rnew

            sux=-xp/rtot        !unit vector perp to diffusion surf
            suy=-yp/rtot
            suz=-zp/rtot

            call isotrp(sux,suy,suz,ux,uy,uz) !emit isotropically from surf
c     **** call limbdark instead!!!!!!!  071902
            cost=uz
            sint=dsqrt(1.d0-cost*cost)
            cosp=ux/sint
            sinp=uy/sint
            phi=datan2(sinp,cosp)

c     find new disk surface temperature

            dA=2.d0*pi*rarr(ir)**2*(costarr(it)-costarr(it+1)) !assumes 2-D

            T4d=tdust(ir,it,ip)*tdust(ir,it,ip)
            T4d=T4d*T4d
            
            T4s=Tstar*Tstar
            T4s=T4s*T4s
            
c            T4=T4d+4*pi*T4s/(nphot*dA) !surf temp
c     testing!
            T4=T4d+2.*pi*T4s/(nphot*dA) !surf temp
            Tdust(ir,it,ip)=min(1600.d0/11605.d0,T4**0.25)

c              determine temperature in disk interior

               nacc=0
               i=ir
               do while (diffdir(i,it,ip) .eq. -1)
                  nacc=nacc+nabs(i,it,ip) !accumulate accretion photon counter
                  i=i+1
               end do

               T4d=T4 !initialize integration variable to surf temp
               i=ir+1
               do while (diffdir(i,it,ip) .eq. -1)
                     idust2=dustarr(i,it,ip)
                     T4d=T4d+(3.*pi*T4s/(nphot*dA))*nacc
     +                 *kappav(idust2)*rsol*rstar*densarr(i-1,it,ip)
     +                *chiR(sngl(tdust(i-1,it,ip)),idust2)*(rarr(i)-
     +		     rarr(i-1))
                     tdust(i,it,ip)=min(1600.d0/11605.d0,T4d**0.25)
                     nacc=nacc-nabs(i-1,it,ip)
                     i=i+1
               end do

c     get photon temperature using grey atm approximation

            T4eff=4.*pi*T4s*nacc/(dA*nphot)
            
            mu=ux*sux+uy*suy+uz*suz
            T=min((T4+0.75*mu*T4eff)**0.25,1600.d0/11605.d0)
            
            nub=dBBfreq(sngl(T),idust2)
            
            ir=ir-1             !move pointer to first cell below diffusion layer
            
            ii(1)=ir
            
            
         elseif (abs(diffdir(ir,it,ip)) .eq. 2) then

c     diffuse to top or bottom of disk

            if (diffdir(ir,it,ip) .eq. -2) then
               do while (diffus(ir,it,ip))
                  it=it-1
               enddo
               it=it+1
            else
               do while (diffus(ir,it,ip))
                  it=it+1
               enddo
            endif
c     print*,'r,it',rarr(ir),it
c     get photon position at diffusion layer
            cosb=zp/rtot
            sinb=dsqrt(1.d0-cosb*cosb)
            cosbnew=1.00001*costarr(it)
            sinbnew=dsqrt(1.d0-cosbnew*cosbnew)
            xp=xp*sinbnew/sinb  !move photon
            yp=yp*sinbnew/sinb
            rp=dsqrt(xp**2+yp**2)
            zp=rtot*cosbnew
c     zp=rtot*sign(1.00001*abs(costarr(it)),costarr(it))
c     calculate mu of disk at position of photon
            mu=costarr(it)
            sth=sintarr(it)
c     unit vector perpendicular to surface
            if (mu .gt. 0.d0) then
               sux=-mu*xp/sth/rtot
               suy=-mu*yp/sth/rtot
               suz=sth
            else
               sux=mu*xp/sth/rtot
               suy=mu*yp/sth/rtot
               suz=-sth
            endif
c     get isotropic emission for photon
            call isotrp(sux,suy,suz,ux,uy,uz)
c     **** call limbdark instead!!!!!!!  071902
            cost=uz
            sint=dsqrt(1.d0-cost*cost)
            cosp=ux/sint
            sinp=uy/sint
            phi=datan2(sinp,cosp)
c     reassign cost,cosp, etc
            if (costarr(it).lt.0.d0) then
               it=it-1
            endif

c     find new disk surface temperature

            dA=pi*sth*(rarr(ir+1)**2-rarr(ir)**2) !assumes 2-D

            T4d=tdust(ir,it,ip)*tdust(ir,it,ip)
            T4d=T4d*T4d
            
            T4s=Tstar*Tstar
            T4s=T4s*T4s
            
c     T4=T4d+4*pi*Rstar**2*T4s/(Lsfrac*Nphot*dA)
c            T4=T4d+4*pi*T4s/(nphot*dA) !surf temp
c     testing!
            T4=T4d+2.*pi*T4s/(nphot*dA) !surf temp
            Tdust(ir,it,ip)=min(1600.d0/11605.d0,T4**0.25)

c           determine temperature in disk interior

            T4d=T4              !initialize integration variable to surf temp

            if (diffdir(ir,it,ip) .eq. -2) then

               nacc=0
               i=it
               do while (diffdir(ir,i,ip) .eq. -2)
                  nacc=nacc+nabs(ir,i,ip) !accumulate accretion photon counter
                  i=i+1
               end do

               i=it+1
               do while (diffdir(ir,i,ip) .eq. -2)
                  idust2=dustarr(ir,i,ip)
                  T4d=T4d+(3.*pi*T4s/(nphot*dA))*nacc
     +                 *kappav(idust2)*rsol*rstar*densarr(ir,i-1,ip)
     +                 *chiR(sngl(Tdust(ir,i-1,ip)),idust2)
     +                 *0.5*(rarr(ir)+rarr(ir+1))
     +                 *(thetarr(i)-thetarr(i-1))
                  tdust(ir,i,ip)=min(1600.d0/11605.d0,T4d**0.25)
                  nacc=nacc-nabs(ir,i-1,ip)
                  i=i+1
               end do

            else

               nacc=0
               i=it
               do while (diffdir(ir,i,ip) .eq. 2)
                  nacc=nacc+nabs(ir,i,ip) !accumulate accretion photon counter
                  i=i-1
               end do

               i=it-1
               do while (diffdir(ir,i,ip) .eq. 2)
c                  idust2=dustarr(ir,i,ip)
                  idust2=dustarr(ir,i+1,ip)
                  T4d=T4d+(3.*pi*T4s/(nphot*dA))*nacc
     +                 *kappav(idust2)*rsol*rstar*densarr(ir,i+1,ip)
     +                 *chiR(sngl(tdust(ir,i+1,ip)),idust2)
     +                 *0.5*(rarr(ir)+rarr(ir+1))
     +                 *(thetarr(i+2)-thetarr(i+1))
                  tdust(ir,i,ip)=min(1600.d0/11605.d0,T4d**0.25)
                  nacc=nacc-nabs(ir,i+1,ip)
                  i=i-1
               end do


            endif

c     get photon temperature using grey atm approximation

c     T4eff=3.*Lacc*(Rstar/r)**3*(1.-sqrt(Rstar/r))*T4s
            T4eff=4.*pi*T4s*nacc/(dA*nphot)
            
            mu=ux*sux+uy*suy+uz*suz
            T=min((T4+0.75*mu*T4eff)**0.25,1600.d0/11605.d0)

            nub=dBBfreq(sngl(T),idust2)
            
            if (diffdir(ir,it,ip) .eq. -2) then
               it=it-1
            else
               it=it+1
            endif
            
            ii(2)=it
            
         elseif (abs(diffdir(ir,it,ip)).eq.3) then
            write(*,*) 'error, phi diffusion not supported'
            stop
         else
            write(*,*) 'error, unknown diffusion direction'
            stop
         endif

      endif
      
c      print*,'rsq.rtot,zp',rsq,rtot,zp,ir,it,ip,diffus(ir,it,ip)


      return
      end
      

c     **********************************************************
