c     **********************************************************

      subroutine tauint(iphot,tsum,ii,r2p,eps,idust2)

      implicit none

      include 'taunum.txt'
      include 'tts.txt'
      include 'opacin.txt'
      include 'grid.txt'
      include 'dust.com'

      real*8 tsum,dt,opac,dtau,ds,beta,lp1,r2p,eps,deps,dtau_eps
     1     ,rsqnew,xpnew,ypnew,zpnew
      integer ioffset(3),ii(3),iphot,it,ir,ip,ir1,it1,ip1,idust2,id

      character routine*20

      routine='tauint_3d'
      tsum=0.d0

c     print*,'eps',eps
c      print*,'rsq.rtot,zp',rsq,rtot,zp,ii(1),ii(2),ii(3)
c      print*,'xp,yp,zp,ux,uy,uz',xp,yp,zp,ux,uy,uz

10    continue
      call testgrid(xp,yp,zp,rsq,rtot,ii,routine,iphot,r2p,uz)
      ir=ii(1)
      it=ii(2)
      ip=ii(3)
      idust2=dustarr(ir,it,ip)

      if (npg.gt.2.and.ntg.gt.2) then
         call find_wall(dt,ioffset,aarr(ip),aarr(ip+1),barr(ip)
     &        ,barr(ip+1),0.d0,0.d0,0.d0,0.d0,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux,uy,uz,xp,yp,zp)
c     print*,'dt ',dt
c     print*,'ioffsets ',ioffset(1),ioffset(2),ioffset(3)
      else if (ntg.gt.2) then
         call find_wall_2D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux,uy,uz,xp,yp,zp)
      else
         call find_wall_1D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,ux,uy,uz,xp,yp,zp)
      endif

c     print*,'dt,ir,r,arr(ir),rarr(ir+1)'
c     print*,dt,ir,dsqrt(rsq),rarr(ir),rarr(ir+1)
      if (dt.lt.0.d0) then
         print*,'problem with find_wall! did not find surface! '
         print*,'in tauint,ir,rtot2,r2arr(ir)',ir,rsq,r2arr(ir)
         print*,'ux,uy,uz,iphot',ux,uy,uz,iphot
         print*,'xtot,ytot,ztot',xp,yp,zp
         dt=eps*(rarr(ir+1)-rarr(ir))
c     stop
      endif

c     optical depth to edge of cell (add small amount because we
c     will increment distance by a small amount)
c      if (tdust(ir,it,ip).lt.1599./11605.) then
c         opac=kapd(idust2)*densarr(ir,it,ip)
c      else
c         opac=0.d0
c      endif
      if (nodust(ir,it,ip)) then
         opac=0.d0
c     assumes only opacity source is dust
      else
         opac=kapd(idust2)*densarr(ir,it,ip)
      endif
      deps=(rarr(ir+1)-rarr(ir))*eps
c     deps=dt*eps
c     if (deps.lt.eps) then
c     deps=eps
c     print*,'setting deps=eps'
c     endif
      dtau_eps=opac*deps
      if (dtau_eps.gt.0.01) then
         print*,''
         print*,'WARNING, in tauint_3d'
         print*,'deps is too big, opac*deps',dtau_eps
         print*,''
      endif
      dtau=opac*dt+dtau_eps
c      if (ir.eq.1) then
c         print*, 'rtot,dr,dthet,dt,deps',rtot,rarr(ir+1)-rarr(ir),
c     1        thetarr(it+1)-thetarr(it),dt,deps
c      endif
c     print*,'dtau,tau ',dtau,tau
c     test to see if tau is exceeded before cell wall reached.
c     if so, calculate distance where this happens.  
      if ((tsum+dtau).gt.tau) then
         ds=(tau-tsum)/opac
         dtauabs(ir,it,ip)=dtauabs(ir,it,ip)+
     +        ds*kapd(idust2)*densarr(ir,it,ip)*(1.d0-albedo(idust2))
         xp=xp+ds*ux
         yp=yp+ds*uy
         zp=zp+ds*uz
         rsq=xp**2+yp**2+zp**2
         rtot=dsqrt(rsq)
c        we are done with optical depth integration
         go to 300
      endif

      ii(1)=ii(1)+ioffset(1)
      ii(2)=ii(2)+ioffset(2)
      ii(3)=ii(3)+ioffset(3)
c     account for crossing the phi=0 plane:
      if (ii(3).eq.0) ii(3)=npg-1
      if (ii(3).eq.npg) ii(3)=1

c     print*,'eps',eps

c     print*,'deps',deps
c     print*,'dt',dt
c     print*,'dt,dt+deps',dt,dt+deps
 50   xpnew=xp+(dt+deps)*ux
      ypnew=yp+(dt+deps)*uy
      zpnew=zp+(dt+deps)*uz
      dtauabs(ir,it,ip)=dtauabs(ir,it,ip)+(dt+deps)*
     +     kapd(idust2)*densarr(ir,it,ip)*(1.d0-albedo(idust2))
c     print*,''
c     print*,'albedo, dtauabs, dtau'
c     print*,albedo(idust2),dtauabs(ir,it,ip), dtau
      rsqnew=xpnew*xpnew+ypnew*ypnew+zpnew*zpnew
      if ((rsqnew-rsq).eq.0.d0) then
         print*,''
         print*,'ERROR, in tauint_3d'
         print*,'rsqnew=rsq, step size too small'
         print*,'increasing deps'
         deps=deps*2.d0
         go to 50
      endif
      xp=xpnew
      yp=ypnew
      zp=zpnew
      rsq=rsqnew
      rtot=dsqrt(rsq)
      tsum=tsum+dtau

c     print*,'new rsq,ir,r2arr(ir),r2arr(ir+1)'
c     print*,(rsq),ii(1)
c     ir=ii(1)
c     print*,r2arr(ir)
c     print*,r2arr(ir+1)
c     print*,'new xp,yp,zp,rsq,rminsq ',xp,yp,zp,rsq,rminsq
c     print*,'r2arr(nrg),rminsq'
c     print*,r2arr(nrg)
c     print*,rminsq

c     testing to see if photon exits
      if (rsq.gt.r2arr(nrg)) then
c        photon exits system
         exitflag=1
         go to 300
      endif

      if (rsq.lt.r2arr(1)) then
c      print*,'rsq,rminsq ',rsq,r2arr(1)
c      print*, 'photon absorbed by star'
         aflux=aflux+1.d0
c         aflag=1
c        back up slightly to get above surface
 60      xp=xp-2.d0*(deps)*ux
         yp=yp-2.d0*(deps)*uy
         zp=zp-2.d0*(deps)*uz
         rsq=xp*xp+yp*yp+zp*zp
         if (rsq.lt.r2arr(1)) then
            print*,'in tauint_3d, still under star',rsq,r2arr(1)
            go to 60
         endif
         rtot=dsqrt(rsq)
c     reemit thermal photon
         call initpabs
         call opacset(sngl(nub))
         wave=1.2398/nub
         ior=1
         iflag=0
c     wave=2.99792458d14/nub
c     print*,'nub',nub
c     print*,'wave',nub
	   idust2=dustarr(1,1,1)
	   do id=1,4
           kapd(id)=kappa(id)*rsol*rstar*kappav(id)
         enddo
c     print*,'kappa,kappav,kapd',kappa,kappav,kapd
         rlam(idust2)=albedo(idust2)
         ir=1
         ii(1)=1
         tsum=0.d0
      endif

      go to 10

300   continue
c      call testgrid(xp,yp,zp,rsq,rtot,ii,'end of tau',iphot,r2p,uz)
c      print*,'rsq,rtot,zp,ii',rsq,rtot,zp,ii
c      print*,'xp,yp,zp,ux,uy,uz',xp,yp,zp,ux,uy,uz
      return
      stop
      end

